<template>
    <div>
        <el-card class="!border-none mb-4" shadow="never">
            <el-form
                class="mb-[-16px]"
                :model="queryParams"
                inline
            >
                <el-form-item label="一级标题" prop="first_title">
                    <el-input class="w-[280px]" v-model="queryParams.first_title" clearable placeholder="请输入一级标题" />
                </el-form-item>
                <el-form-item label="二级标题" prop="second_title">
                    <el-input class="w-[280px]" v-model="queryParams.second_title" clearable placeholder="请输入二级标题" />
                </el-form-item>
                <el-form-item label="显示状态" prop="is_show">
                    <el-select class="w-[280px]" v-model="queryParams.is_show" clearable placeholder="请选择显示状态">
                        <el-option label="全部" value=""></el-option>
                        <el-option 
                            v-for="(item, index) in dictData.show_status"
                            :key="index" 
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="显示设备" prop="position">
                    <el-select class="w-[280px]" v-model="queryParams.position" clearable placeholder="请选择显示设备">
                        <el-option label="全部" value=""></el-option>
                        <el-option 
                            v-for="(item, index) in dictData.banner_position"
                            :key="index" 
                            :label="item.name"
                            :value="item.value"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button type="primary" @click="resetPage">查询</el-button>
                    <el-button @click="resetParams">重置</el-button>
                </el-form-item>
            </el-form>
        </el-card>
        <el-card class="!border-none" v-loading="pager.loading" shadow="never">
            <el-button v-perms="['banner.banner/add']" type="primary" @click="handleAdd">
                <template #icon>
                    <icon name="el-icon-Plus" />
                </template>
                创建
            </el-button>
            <el-button
                v-perms="['banner.banner/delete']"
                :disabled="!selectData.length"
                @click="handleDelete(selectData)"
            >
                删除
            </el-button>
            <div class="mt-4">
                <el-table :data="pager.lists" @selection-change="handleSelectionChange">
                    <el-table-column type="selection" width="55" />
                    <el-table-column label="显示位置" prop="position">
                        <template #default="{ row }">
                            <dict-value :options="dictData.banner_position" :value="row.position" />
                        </template>
                    </el-table-column>
                    <el-table-column label="用户平台" prop="platform">
                        <template #default="{ row }">
                            <dict-value :options="dictData.platform" :value="row.platform" />
                        </template>
                    </el-table-column>
                    <el-table-column label="配置图片" prop="image">
                        <template #default="{ row }">
                            <image-contain
                                v-if="row.image"
                                :src="row.image"
                                :width="60"
                                :height="45"
                                :preview-src-list="[row.image]"
                                preview-teleported
                                fit="contain"
                            />
                        </template>
                    </el-table-column>
                    <el-table-column label="一级标题" prop="first_title" show-overflow-tooltip />
                    <el-table-column label="二级标题" prop="second_title" show-overflow-tooltip />
                    <el-table-column label="显示状态" prop="is_show">
                        <template #default="{ row }">
                            <dict-value :options="dictData.show_status" :value="row.is_show" />
                        </template>
                    </el-table-column>
                    <el-table-column label="显示权重" prop="sort" show-overflow-tooltip />
                    <el-table-column label="跳转地址" prop="navigate" show-overflow-tooltip />
                    <el-table-column label="操作" width="120" fixed="right">
                        <template #default="{ row }">
                            <el-button
                                v-perms="['banner.banner/edit']"
                                type="primary"
                                link
                                @click="handleEdit(row)"
                            >
                                编辑
                            </el-button>
                            <el-button
                                v-perms="['banner.banner/delete']"
                                type="danger"
                                link
                                @click="handleDelete(row.id)"
                            >
                                删除
                            </el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
            <div class="flex mt-4 justify-end">
                <pagination v-model="pager" @change="getLists" />
            </div>
        </el-card>
        <edit-popup v-if="showEdit" ref="editRef" :dict-data="dictData" @success="getLists" @close="showEdit = false" />
    </div>
</template>

<script lang="ts" setup name="bannerLists">
import { usePaging } from '@/hooks/usePaging'
import { useDictData } from '@/hooks/useDictOptions'
import { apiBannerLists, apiBannerDelete } from '@/api/banner'
import feedback from '@/utils/feedback'
import EditPopup from './edit.vue'

const editRef = shallowRef<InstanceType<typeof EditPopup>>()
// 是否显示编辑框
const showEdit = ref(false)


// 查询条件
const queryParams = reactive({
    first_title: '',
    second_title: '',
    is_show: '',
    position: ''
})

// 选中数据
const selectData = ref<any[]>([])

// 表格选择后回调事件
const handleSelectionChange = (val: any[]) => {
    selectData.value = val.map(({ id }) => id)
}

// 获取字典数据
const { dictData } = useDictData('show_status,banner_position,platform')

// 分页相关
const { pager, getLists, resetParams, resetPage } = usePaging({
    fetchFun: apiBannerLists,
    params: queryParams
})

// 添加
const handleAdd = async () => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('add')
}

// 编辑
const handleEdit = async (data: any) => {
    showEdit.value = true
    await nextTick()
    editRef.value?.open('edit')
    editRef.value?.setFormData(data)
}

// 删除
const handleDelete = async (id: number | any[]) => {
    await feedback.confirm('确定要删除？')
    await apiBannerDelete({ id })
    getLists()
}

getLists()
</script>

